var currentMemberNumber = '';
var video = document.createElement("video");

// add some additional buttons to the shotlist
var global_customShotlistButtons = function(panel, showSaveButton) {
    var div = $('<div class="bentheim-panel" />');
    if (!cur_string().data.bentheim_shooter) {
        var item = $("<button id='cmdLoginMember' class='wide_button bentheim'>Anmelden</button>");
        div.append(item);   
        div.append('<br>');
        item.on('click', function() { 
            updateCurrentMemberNumber();
            $('#modal-login').removeClass('hidden'); 
        });
        panel.append(div);

        return true;
    } else {
        div.append('<span class="member-number">Mitglied: ' + cur_string().data.bentheim_shooter + '</span><br>');   
   
        var logoutBtn = $("<button id='cmdLogoutMember' class='wide_button bentheim'>Abmelden</button>");
        div.append(logoutBtn);   
        div.append('<br>');
        logoutBtn.on('click', function() { 
            var result = confirm("Möchten Sie wirklich abmelden?");
            if (!result) return;

            currentMemberNumber = ''; 
            //set_cookie('bentheim.recentmember', '');
            cur_string().crud({ bentheim_shooter: false });
        });

        var beginStringBtn = $("<button id='cmdBeginString' class='wide_button bentheim'>Starten</button>");
        beginStringBtn.on('click', function() { 
            cur_string().crud({ bentheim_begin: Date.now() });
        });

        var saveStringBtn = $("<button id='cmdSaveString' class='wide_button bentheim'>Speichern</button>");
        saveStringBtn.on('click', function() {
            var result = confirm("Möchten Sie die aktuelle Serie speichern?");
            if (!result) return;

            // send picture to server...
            var string =  cur_string();
            // var dataURL = maintarget.canvas[0].toDataURL();
            // $.ajax({
            //     type: "POST",
            //     url: "/bentheim-upload-targetface",
            //     data: { 
            //         stringId: string.data._id,
            //         img: dataURL,
            //     }
            //   }).done(function(o) {
            //     console.log('saved'); 
            //   });

            var data = { 
                bentheim_end: Date.now(), 
                bentheim_face: cur_string().face().data.name, 
                bentheim_range: cur_string().frame().data.name 
            };
            string.crud(data);
            save_string(string, "Saved " + string.data.bentheim_shooter);
        });

        var cancelStringBtn = $("<button id='cmdCancelString' class='wide_button bentheim'>Abbrechen</button>");
        cancelStringBtn.on('click', function() { 
            var result = confirm("Möchten Sie die aktuelle Serie verwerfen?");
            if (!result) return;
            var string =  cur_string();
            string.crud({ bentheim_canceled: true });
            save_string(string, "Canceled " + string.data.bentheim_shooter);
        });

        if (!cur_string().data.bentheim_begin) {
            saveStringBtn.attr('disabled', 'disabled');
            cancelStringBtn.attr('disabled', 'disabled');
            beginStringBtn.attr('disabled', undefined);
        } else {
            saveStringBtn.attr('disabled', undefined);
            cancelStringBtn.attr('disabled', undefined);
            beginStringBtn.attr('disabled', 'disabled');
        }

        div.append(beginStringBtn);   
        div.append('<br>');
        div.append(saveStringBtn);   
        div.append('<br>');
        div.append(cancelStringBtn);   
        div.append('<br>');

        panel.append(div);

        return false;
    }

};

// Override facenames...
var facenameOverrides = {
    'DJV-109': 'DJV109 Anschuss',
    'DJV_02_Ueberlaeufer-Folie': 'DJV002 Überläufer',
    'DJV_03_Fuchs-Folie': 'DJV003 Fuchs',
    'DJV_01_Reh-Folie': 'DJV001 Rehbock',
};
var global_customFaceName = function(name) {
    if (facenameOverrides[name] !== undefined) return facenameOverrides[name];
    return name;
}

var updateCurrentMemberNumber = function() {
    $('#memberNumber').html(currentMemberNumber);
};

$(window).on('load', function(){
    // add a hidden modal...
    var htmlModal = `
        <div id="modal-login" class="hidden">
            <div class="content">
                <div id="memberNumber"></div>
                
                <div id="qrCodeArea" style="display:none;">
                    <div id="loadingMessage" hidden="">⌛ Loading video...</div>
                    <canvas id="canvas" height="480" width="640"></canvas>
                    <div id="output">
                    <div id="outputMessage">No QR code detected.</div>
                    <div hidden=""><b>Data:</b> <span id="outputData"></span></div>
                    </div>
                </div>

                <div style="width:100%;clear:left;margin-bottom:30px" id="keyPadArea">
                    <table style="margin:auto">
                        <tr>
                            <td data-value="1"></td>
                            <td data-value="2"></td>
                            <td data-value="3"></td>
                        </tr>
                        <tr>
                            <td data-value="4"></td>
                            <td data-value="5"></td>
                            <td data-value="6"></td>
                        </tr>
                        <tr>
                            <td data-value="7"></td>
                            <td data-value="8"></td>
                            <td data-value="9"></td>
                        </tr>
                        <tr>
                            <td><button id='qrCodeScannerKey' class='bentheim ripple wide_button' style='width:45%;float:left;'><img src="/img.bentheim/qr-code-scan.svg" /></button></td>
                            <td data-value="0"></td>
                            <td><button id='memberNumberRemoveKey' class='bentheim ripple wide_button' style='width:45%;float:left;'><img src="/img.bentheim/line-angle-left.svg" style='height:20px;' /></button></td>
                        </tr>
                    </table>
                </div>
                <div style="clear:left;">
                    <button id='cmdModalLoginLogin' class='bentheim ripple wide_button' style="width:45%;float:left;">Login</button>
                    <button id='cmdModalLoginClose' class='bentheim ripple wide_button' style="width:45%;float:right;">Abbrechen</button>
                </div>

            </div>
        </div>
    `;
    var modal = $(htmlModal);
    $('body').append(modal);

    updateCurrentMemberNumber();

    $('#cmdModalLoginClose').on('click', function() { 
        closeModal();
    });
    modal.find('[data-value]').each(function(i, v) {
        var elem = $(v);
        elem.html("<button class='bentheim ripple numberkey' style='width:45%;float:left;'>" + elem.data('value') + "</button>");
    });
    $('button.numberkey').on('click', function(event) {
        var value = $(event.target).closest('[data-value]').data('value');
        currentMemberNumber += value;
        updateCurrentMemberNumber();
    });
    $('#memberNumberRemoveKey').on('click', function(event) {
        currentMemberNumber = currentMemberNumber.slice(0, -1);;
        updateCurrentMemberNumber();
    });
    $('#qrCodeScannerKey').on('click', function(event) {
        qrCodeReader();
    });
    $('#cmdModalLoginLogin').on('click', function() { 
        // check member id is 4 or more than 11 characters long...
        if (currentMemberNumber.length === 4 || currentMemberNumber.length >= 9) {
            //set_cookie("bentheim.recentmember", currentMemberNumber);
            cur_string().crud({ bentheim_shooter: currentMemberNumber });
            closeModal();
        }
    });

    function closeModal() {
        $('#modal-login').addClass('hidden');
        $('#modal-login').addClass('hidden');
        if (video.srcObject) video.srcObject.getTracks().forEach(track => track.stop());
        $('#keyPadArea').css('display', 'inline');
        $('#qrCodeArea').css('display', 'none');
    };

    function qrCodeReader() {
        
        $('#keyPadArea').css('display', 'none');
        $('#qrCodeArea').css('display', 'inline');

        var canvasElement = document.getElementById("canvas");
        var canvas = canvasElement.getContext("2d");
        var loadingMessage = document.getElementById("loadingMessage");
        var outputContainer = document.getElementById("output");
        // var outputMessage = document.getElementById("outputMessage");
        // var outputData = document.getElementById("outputData");
    
        function drawLine(begin, end, color) {
          canvas.beginPath();
          canvas.moveTo(begin.x, begin.y);
          canvas.lineTo(end.x, end.y);
          canvas.lineWidth = 4;
          canvas.strokeStyle = color;
          canvas.stroke();
        }
    
        // Use facingMode: environment to attemt to get the front camera on phones
        navigator.mediaDevices.getUserMedia({ video: { facingMode: "user" } }).then(function(stream) {
          video.srcObject = stream;
          video.setAttribute("playsinline", true); // required to tell iOS safari we don't want fullscreen
          video.play();
          requestAnimationFrame(tick);
        });
    
        function tick() {
          loadingMessage.innerText = "⌛ Loading video..."
          if (video.readyState === video.HAVE_ENOUGH_DATA) {
            loadingMessage.hidden = true;
            canvasElement.hidden = false;
            outputContainer.hidden = false;
    
            canvasElement.height = video.videoHeight;
            canvasElement.width = video.videoWidth;
            canvas.drawImage(video, 0, 0, canvasElement.width, canvasElement.height);
            var imageData = canvas.getImageData(0, 0, canvasElement.width, canvasElement.height);
            var code = jsQR(imageData.data, imageData.width, imageData.height, {
              inversionAttempts: "dontInvert",
            });
            if (code) {
              drawLine(code.location.topLeftCorner, code.location.topRightCorner, "#FF3B58");
              drawLine(code.location.topRightCorner, code.location.bottomRightCorner, "#FF3B58");
              drawLine(code.location.bottomRightCorner, code.location.bottomLeftCorner, "#FF3B58");
              drawLine(code.location.bottomLeftCorner, code.location.topLeftCorner, "#FF3B58");
            //   outputMessage.hidden = true;
            //   outputData.parentElement.hidden = false;
            //   outputData.innerText = code.data;
              currentMemberNumber = code.data;
              updateCurrentMemberNumber();
              $('#cmdModalLoginLogin').trigger('click');

            } else {
            //   outputMessage.hidden = false;
            //   outputData.parentElement.hidden = true;
            }
          }
          requestAnimationFrame(tick);
        }
    }

});