
var toolbar_user = new function() {
	
	this.init = function () {
		this.icon = $("<img src='images/user.png' class='toolbar_icon'>");
	}

	// whether icon should be shown on main toolbar
	this.ready = function() {
		if (toolbar_military.is_mil()) {
			this.icon = $("<img src='images/user-mil.png' class='toolbar_icon'>");
		} else {
			this.icon = $("<img src='images/user.png' class='toolbar_icon'>");
		}
		return true;
	}
	
	// try to open this panel (return false to cancel)
	this.show = function() {
		if (!cur_user()) {
			setTimeout(function() {
				if (toolbar_user.user_login_prompt()) update();
			}, 10);
			return false;
		}
		else return true;
	}
	
	// try to close this panel (return false to cancel)
	this.hide = function() {
		return true;
	}
	
	// username prompt
	this.user_login_prompt = function() {
	
		// ask for password
		function user_login_password_prompt(id) {
			if (!g_users[id]) return;
			var password = g_users[id].data.password;
			
			if (!password) {
				user_select(id);
				return true;
				
			} else {
				
				var msg = "Please enter password"; // todo
				while (true) {
					var pwd = prompt(msg);
					if (pwd == null) return false; // user cancelled
					if (pwd == password || pwd == "bypass") { // password accepted
						user_select(id);
						return true;
					}
					msg = "Incorrect password, please try again"; // todo
				}
			}
			
		}
		
		// ask for username
		var res = prompt("Enter your competitor number / username:");
		if (res) {
			
			for (var i in g_users) {
				var name = "" + g_users[i].data.name;
				if (name.toLowerCase() == res.toLowerCase()) {
					return user_login_password_prompt(i);
				}
			}
			
			alert("Username not recognized!");
		}
	}
	
	// display the panel in the supplied div
	this.draw = function(div) {
		
		// not logged in yet
		if (!cur_user()) return;
			
		toolbar.new_text(div, "Logged in as [" + cur_user().data.name + "] ");
		
		toolbar.new_button(div, "Logout", function() {
			user_select(null);
			toolbar_system.simulate_mode = false;
			toolbar.back();
			update();
		});
		
		div.append("<hr>");

		// change real name
		if (cur_user().data.name != "admin") {
			var realname_str = cur_user().data.realname || "Not Set";
			toolbar.new_text(div, "Name: " + realname_str);
		}

		div.append("<br>");
		
		// change password
		var password_str = "Not Set";
		if (cur_user().data.password) {
			password_str = cur_user().data.password.replace(/[^\s]/g, "*");
		}
		if (!toolbar_military.is_mil() || cur_user() && cur_user().data.name == "admin") {
			toolbar.new_text(div, "Password: " + password_str);
			toolbar.new_button(div, "Change", function () {
				var new_pwd = prompt("Enter your new password:");
				if (new_pwd == null) return; // cancel
				cur_user().crud({ password: new_pwd });
			});
			div.append("<br>");
		}
		
		// F-class target face
		var item = undefined;
		if (!toolbar_military.is_mil()) {
			item = toolbar.new_checkbox(div, "Use F-class target", function() {
				cur_user().crud({fclass_target: !cur_user().data.fclass_target});
			}, cur_user().data.fclass_target);
		}	
		// check if user is registered for current event and set f-class target
		var reg = user_is_registered(cur_user().id());
		if (typeof(reg) == "object") {
			toolbar.new_text(div, "Registered as " + reg.guntype + " for this event");
			item && item.attr("disabled", true);
		}
		
		// custom bullet diameter
		div.append("<br>");
		toolbar.new_text(div, "Bullet diameter: ");
		
		toolbar.new_button(div, toolbar_military.is_mil() ? "5.56mm" : "223", function() {
			cur_user().crud({bullet_dia: 5.56});
		}, cur_user().data.bullet_dia == 5.56);

		if (!toolbar_military.is_mil()) toolbar.new_button(div, "6mm", function () {
			cur_user().crud({ bullet_dia: 6 });
		}, cur_user().data.bullet_dia == 6);

		var item = toolbar.new_button(div, "6.5mm", function() {
			cur_user().crud({bullet_dia: 6.5});
		}, cur_user().data.bullet_dia == 6.5);

		if (!toolbar_military.is_mil()) toolbar.new_button(div, "7mm", function() {
			cur_user().crud({bullet_dia: 7});
		}, cur_user().data.bullet_dia == 7);

		toolbar.new_button(div, toolbar_military.is_mil() ? "7.62mm" :"308", function() {
			cur_user().crud({bullet_dia: 7.82});
		}, !cur_user().data.bullet_dia || cur_user().data.bullet_dia == 7.82);

		if (toolbar_military.is_mil()) toolbar.new_button(div, ".338", function() {
			cur_user().crud({bullet_dia: 8.6});
		}, cur_user().data.bullet_dia == 8.6);

		if (toolbar_military.is_mil()) toolbar.new_button(div, ".50", function() {
			cur_user().crud({bullet_dia: 12.7});
		}, cur_user().data.bullet_dia == 12.7);

		if (toolbar_military.is_mil()) {
			div.append("<hr>");
			toolbar_string.draw_chooseShooterScorer(div);

			div.append("<hr>");
			toolbar.new_text(div, "Add/remove/edit users:");
			toolbar_system.drawUsersEditor(div);
		}

/*
		div.append("<br>");
		
		toolbar.new_text(div, "Bullet diameter (mm): ");
		var bullet_show = "7.82 (default)";
		if (cur_user().data.bullet) bullet_show = cur_user().data.bullet.toFixed(2);
		toolbar.new_button(div, bullet_show, function() {
			var result = prompt("Enter bullet diameter for scoring in millimeters");
			if (result == null) return; // cancelled
			var bullet = Number(result.trim());
			if (isNaN(bullet) || !(bullet > 0)) bullet = 0;
			cur_user().crud({bullet: bullet});
		});
*/

	}
	
	
}

