#!/bin/sh

# 
# $Author: dmc $
# $Revision: 2809 $
# $Date: 2020-08-27 09:44:49 -0300 (Thu, 27 Aug 2020) $
# $HeadURL: http://support2.silvermountaintargets.com/svn/smt/smtv2-lodi/s7_fixup_5g.sh $
#

S7_FSOLO_ip=192.168.0.7
alias sshQFSOLO='ssh  -y -i /www/smtv2/homedir/ssh-dir/id_rsa_smtservice.dropbear root@${S7_FSOLO_ip} 2>/dev/null'

echo
echo checking server type, looking for S7 FSOLO at $S7_FSOLO_ip

if wget -O - http://${S7_FSOLO_ip}/set_altnetwork/${prm} > /dev/null 2>&1
then
	echo
	echo "we are an S7; S7 FSOLO found!  Checking S7's wireless settings..."
	echo
	if [ "11a" != "`uci get wireless.radio0.hwmode`" ]; then
		echo "...S7 main processor not set to 5GHz.... setting now...."
		# do for both Pi3B+ and Pi4:
		uci set wireless.radio0.hwmode='11a' 2>/dev/null
		uci set wireless.radio0.htmode='VHT20' 2>/dev/null
		uci set wireless.radio0.txpower='15' 2>/dev/null
		uci set wireless.radio0.channel='36' 2>/dev/null

		uci set wireless.radio1.hwmode='11a' 2>/dev/null
		uci set wireless.radio1.htmode='VHT20' 2>/dev/null
		uci set wireless.radio1.txpower='15' 2>/dev/null
		uci set wireless.radio1.channel='36' 2>/dev/null

		uci commit 2>/dev/null
	else
		echo "..S7 main processor already set to 5GHz"
	fi

	echo
	echo "Checking S7 wifi processor setting..."

	if [ "HT20" != "`sshQFSOLO uci get wireless.radio0.htmode`" ]; then
		echo "...S7 wifi processor using slow legacy-g mode; changing to high speed N mode"
		sshQFSOLO "uci set wireless.radio0.htmode='HT20'; uci commit"
	else
		echo "...S7 wifi processor already set to high speed N mode"
	fi

	echo
	echo FINISHED
	exit 0

	sshQFSOLO uci show wireless | grep radio
	sshQFSOLO id
	echo "done"
	exit 0
else
	echo
	echo 'we are NOT an S7; FSOLO not found *** or not updated with latest firmware ***'
	exit 3
fi

exit 0


# Pi3B+
wireless.radio0=wifi-device
wireless.radio0.type='mac80211'
wireless.radio0.path='platform/soc/3f300000.mmc/mmc_host/mmc1/mmc1:0001/mmc1:0001:1'
wireless.radio0.country='US'
wireless.radio0.legacy_rates='0'
wireless.radio0.hwmode='11a'
wireless.radio0.htmode='VHT20'
wireless.radio0.txpower='15'
wireless.radio0.channel='40'


root@SMT_S7_server:/etc/config# uci show wireless | fgrep .radio
wireless.radio0=wifi-device
wireless.radio0.type='mac80211'
wireless.radio0.path='platform/soc/3f300000.mmc/mmc_host/mmc1/mmc1:0001/mmc1:0001:1'
wireless.radio0.legacy_rates='1'
wireless.radio0.country='00'
wireless.radio0.txpower='15'
wireless.radio0.hwmode='11a'
wireless.radio0.htmode='VHT20'
wireless.radio0.channel='36'
wireless.radio1=wifi-device
wireless.radio1.type='mac80211'
wireless.radio1.path='platform/soc/fe300000.mmcnr/mmc_host/mmc1/mmc1:0001/mmc1:0001:1'
wireless.radio1.country='00'
wireless.radio1.hwmode='11g'
wireless.radio1.channel='8'
wireless.radio1.txpower='15'




# FSOLO
wireless.radio0=wifi-device
wireless.radio0.type='mac80211'
wireless.radio0.hwmode='11g'
wireless.radio0.path='platform/ar933x_wmac'
wireless.radio0.country='US'
wireless.radio0.txpower='21'
wireless.radio0.channel='1'
wireless.radio0.htmode='HT20'

